﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using Telerik.Windows.Controls.DragDrop;
using Telerik.Windows.Controls;
using System.Collections;
using iwantedue.Windows.Forms;
using System.IO;

namespace WpfApplication14
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            this.DataContext = new ObservableCollection<string>();
        }

        private void RadGridView_DropQuery(object sender, Telerik.Windows.Controls.DragDrop.DragDropQueryEventArgs e)
        {
           // e.QueryResult = e.Options.DropDataObject != null && e.Options.DropDataObject.ContainsFileDropList();

            //display formats available
            this.TextBlock1.Text = "Formats:\n";
            foreach (string format in e.Options.DropDataObject.GetFormats())
            {
                this.TextBlock1.Text += "    " + format + "\n";
            }

            //ensure FileGroupDescriptor is present before allowing drop
            if (e.Options.DropDataObject.GetDataPresent("FileGroupDescriptor"))
            {
                e.Options.Effects = DragDropEffects.All;
                e.QueryResult = true;
            }

        }

        private void RadGridView_DropInfo(object sender, Telerik.Windows.Controls.DragDrop.DragDropEventArgs e)
        {
           // var grid = sender as RadGridView;

            if (e.Options.Status == DragStatus.DropComplete)
            {
                //var collection = grid.ItemsSource as IList;

                //StringCollection fileList = e.Options.DropDataObject.GetFileDropList();
                //foreach (string file in fileList)
                //{
                //    //Take only the file name.
                //    string fileName = file.Substring(file.LastIndexOf(System.IO.Path.DirectorySeparatorChar) + 1, file.Length - file.LastIndexOf(System.IO.Path.DirectorySeparatorChar) - 1);

                //    collection.Add(fileName);
                //}



                //wrap standard IDataObject in OutlookDataObject
                OutlookDataObject dataObject = new OutlookDataObject(e.Options.DropDataObject);

                //get the names and data streams of the files dropped
                string[] filenames = (string[])dataObject.GetData("FileGroupDescriptorW");
                MemoryStream[] filestreams = (MemoryStream[])dataObject.GetData("FileContents");

                this.TextBlock1.Text += "Files:\n";
                for (int fileIndex = 0; fileIndex < filenames.Length; fileIndex++)
                {
                    //use the fileindex to get the name and data stream
                    string filename = filenames[fileIndex];
                    MemoryStream filestream = filestreams[fileIndex];
                    this.TextBlock1.Text += "    " + filename + "\n";

                    //save the file stream using its name to the application path
                    FileStream outputStream = File.Create(filename);
                    filestream.WriteTo(outputStream);
                    outputStream.Close();
                }
            }
        }
    }
}
